﻿//=========================================================
//Description : USB Seriel product demo program for C#
//DLL Version : USBDII.dll V 2.0.0.3
//Release Date : 2010/06/06
//Author : Samuel Tseng
//
//Copyright 2010 Decision Computer
//All Right Reserved
//=========================================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;    // use "Platform Invoke" to import USBDII.DLL


namespace Decision_USB_Dll_Demo
{
    public partial class Form1 : Form
    {

        // User should use type "IntPtr" to replace "handle" in C#.  
        // User should use  declear "unsafe" in "byte *" in C#  
        // and check the property in project->property->build "Allow unsafe code"
         
        [DllImport("USBDII.dll")]
        public static extern IntPtr hid_OpenDevice(uint card_id, uint card_number);
        
        [DllImport("USBDII.dll")]
        public static extern Boolean hid_CloseDevice(IntPtr hUSB);      
 
        [DllImport("USBDII.dll")]  
        public static extern unsafe Boolean hid_GetDigitalByte(IntPtr hUSB, uint address, byte* data);
 
        [DllImport("USBDII.dll")]
        public static extern Boolean hid_SetDigitalByte(IntPtr hUSB, uint address, byte data);

        public IntPtr hDevice;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        // open device 

        private void button1_Click(object sender, EventArgs e) 
        {
            hDevice = hid_OpenDevice(13,0);  
            
            // card_id 13 as USB32RO ; card_number 0 as first device (blue switch setting on the board)

            if (hDevice == (IntPtr)(-1))
                label2.Text = "Open Error!";
            else
                label2.Text = "Handel Value = " + Convert.ToString(hDevice);   
        
            //label2.Text = Convert.ToString(hDevice);  //"123"; 

        }

        // write 3 to port#0

        private void button2_Click(object sender, EventArgs e)
        {

            bool result = hid_SetDigitalByte(hDevice, 0 , 3);

            if (result)
                label2.Text = "Success Write into Port #0";
            else
                label2.Text = "Write Error";

        }

        // write 9 to port#1

        private void button3_Click(object sender, EventArgs e)
        {
            bool result = hid_SetDigitalByte(hDevice, 1, 9);

            if (result)
                label2.Text = "Success Write into Port #1";
            else
                label2.Text = "Write Error";
        }

        // write 127 to port#2

        private void button5_Click(object sender, EventArgs e)
        {
            bool result = hid_SetDigitalByte(hDevice, 2, 127);

            if (result)
                label2.Text = "Success Write into Port #2";
            else
                label2.Text = "Write Error";
        }

        // write 32 to port#3

        private void button4_Click(object sender, EventArgs e)
        {
            bool result = hid_SetDigitalByte(hDevice, 3, 32);

            if (result)
                label2.Text = "Success Write into Port #3";
            else
                label2.Text = "Write Error";
        }

        // close device

        private void button6_Click(object sender, EventArgs e)
        {
            hid_CloseDevice(hDevice);
        }

        // read from all ports

        private void button7_Click(object sender, EventArgs e)
        {
            byte temp;

            unsafe
            {
                label3.Text = "";

                for (uint i = 0; i < 4; i++)
                {
                    hid_GetDigitalByte(hDevice, i, &temp);

                    label3.Text = label3.Text + "\nPort" + Convert.ToString(i) + " = " + Convert.ToString(temp);

                }
            }

        }

        //clear all ports as 0

        private void button8_Click(object sender, EventArgs e)
        {
            for (uint i = 0; i < 4; i++)
            {
                hid_SetDigitalByte(hDevice, i, 0);
            }
        }




    }
}
